<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (version 1.7.0_80) on Wed Sep 20 14:52:14 UTC 2017 -->
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>ExtraPropertiesExtension (Gradle API 4.2)</title>
<meta name="date" content="2017-09-20">
<link rel="stylesheet" type="text/css" href="../../../../javadoc.css" title="Style">
</head>
<body>
<script type="text/javascript"><!--
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="ExtraPropertiesExtension (Gradle API 4.2)";
    }
//-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar_top">
<!--   -->
</a><a href="#skip-navbar_top" title="Skip navigation links"></a><a name="navbar_top_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/plugins/ExtensionContainer.html" title="interface in org.gradle.api.plugins"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.UnknownPropertyException.html" title="class in org.gradle.api.plugins"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/plugins/ExtraPropertiesExtension.html" target="_top">Frames</a></li>
<li><a href="ExtraPropertiesExtension.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested_class_summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.gradle.api.plugins</div>
<h2 title="Interface ExtraPropertiesExtension" class="title">Interface ExtraPropertiesExtension</h2>
</div>
<div class="contentContainer">
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public interface <span class="strong">ExtraPropertiesExtension</span></pre>
<div class="block">Additional, ad-hoc, properties for Gradle domain objects.
 <p>
 Extra properties extensions allow new properties to be added to existing domain objects. They act like maps,
 allowing the storage of arbitrary key/value pairs. All <a href="../../../../org/gradle/api/plugins/ExtensionAware.html" title="interface in org.gradle.api.plugins"><code>ExtensionAware</code></a> Gradle domain objects intrinsically have an extension
 named “<a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.html#EXTENSION_NAME">"ext"</a>” of this type.
 <p>
 An important feature of extra properties extensions is that all of its properties are exposed for reading and writing via the <a href="../../../../org/gradle/api/plugins/ExtensionAware.html" title="interface in org.gradle.api.plugins"><code>ExtensionAware</code></a>
 object that owns the extension.

 <pre class='autoTested'>
 project.ext.set("myProp", "myValue")
 assert project.myProp == "myValue"

 project.myProp = "anotherValue"
 assert project.myProp == "anotherValue"
 assert project.ext.get("myProp") == "anotherValue"
 </pre>

 Extra properties extension objects support Groovy property syntax. That is, a property can be read via <code>extension.«name»</code> and set via
 <code>extension.«name» = "value"</code>. <b>Wherever possible, the Groovy property syntax should be preferred over the
 <a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.html#get(java.lang.String)"><code>get(String)</code></a> and <a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.html#set(java.lang.String,%20java.lang.Object)"><code>set(String, Object)</code></a> methods.</b>

 <pre class='autoTested'>
 project.ext {
   myprop = "a"
 }
 assert project.myprop == "a"
 assert project.ext.myprop == "a"

 project.myprop = "b"
 assert project.myprop == "b"
 assert project.ext.myprop == "b"
 </pre>

 You can also use the Groovy accessor syntax to get and set properties on an extra properties extension.

 <pre class='autoTested'>
 project.ext["otherProp"] = "a"
 assert project.otherProp == "a"
 assert project.ext["otherProp"] == "a"
 </pre>

 The exception that is thrown when an attempt is made to get the value of a property that does not exist is different depending on whether the
 Groovy syntax is used or not. If Groovy property syntax is used, the Groovy <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/MissingPropertyException.html?is-external=true" title="class or interface in groovy.lang"><code>MissingPropertyException</code></a> will be thrown.
 When the <a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.html#get(java.lang.String)"><code>get(String)</code></a> method is used, an <a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.UnknownPropertyException.html" title="class in org.gradle.api.plugins"><code>ExtraPropertiesExtension.UnknownPropertyException</code></a> will be thrown.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== NESTED CLASS SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="nested_class_summary">
<!--   -->
</a>
<h3>Nested Class Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Nested Class Summary table, listing nested classes, and an explanation">
<caption><span>Nested Classes</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Interface and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static class&nbsp;</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.UnknownPropertyException.html" title="class in org.gradle.api.plugins">ExtraPropertiesExtension.UnknownPropertyException</a></strong></code>
<div class="block">The exception that will be thrown when an attempt is made to read a property that is not set.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.html#EXTENSION_NAME">EXTENSION_NAME</a></strong></code>
<div class="block">The name of this extension in all <a href="../../../../org/gradle/api/plugins/ExtensionContainer.html" title="interface in org.gradle.api.plugins"><code>ExtensionContainers</code></a>, "ext".</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method_summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="overviewSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span>Methods</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.html#get(java.lang.String)">get</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;name)</code>
<div class="block">Returns the value for the registered property with the given name.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&gt;</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.html#getProperties()">getProperties</a></strong>()</code>
<div class="block">Returns all of the registered properties and their current values as a map.</div>
</td>
</tr>
<tr class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.html#has(java.lang.String)">has</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;name)</code>
<div class="block">Returns whether or not the extension has a property registered via the given name.</div>
</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><strong><a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.html#set(java.lang.String,%20java.lang.Object)">set</a></strong>(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;name,
   <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;value)</code>
<div class="block">Updates the value for, or creates, the registered property with the given name to the given value.</div>
</td>
</tr>
</table>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field_detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="EXTENSION_NAME">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>EXTENSION_NAME</h4>
<pre>static final&nbsp;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a> EXTENSION_NAME</pre>
<div class="block">The name of this extension in all <a href="../../../../org/gradle/api/plugins/ExtensionContainer.html" title="interface in org.gradle.api.plugins"><code>ExtensionContainers</code></a>, "ext".</div>
<dl><dt><span class="strong">See Also:</span></dt><dd><a href="../../../../constant-values.html#org.gradle.api.plugins.ExtraPropertiesExtension.EXTENSION_NAME">Constant Field Values</a></dd></dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method_detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="has(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>has</h4>
<pre>boolean&nbsp;has(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;name)</pre>
<div class="block">Returns whether or not the extension has a property registered via the given name.

 <pre class='autoTested'>
 assert project.ext.has("foo") == false
 assert project.hasProperty("foo") == false

 project.ext.foo = "bar"

 assert project.ext.has("foo")
 assert project.hasProperty("foo")
 </pre></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>name</code> - The name of the property to check for</dd>
<dt><span class="strong">Returns:</span></dt><dd><code>true</code> if a property has been registered with this name, otherwise <code>false</code>.</dd></dl>
</li>
</ul>
<a name="get(java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>get</h4>
<pre><a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;get(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;name)
           throws <a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.UnknownPropertyException.html" title="class in org.gradle.api.plugins">ExtraPropertiesExtension.UnknownPropertyException</a></pre>
<div class="block">Returns the value for the registered property with the given name.

 When using an extra properties extension from Groovy, you can also get properties via Groovy's property syntax.
 All of the following lines of code are equivalent.

 <pre class='autoTested'>
 project.ext { foo = "bar" }

 assert project.ext.get("foo") == "bar"
 assert project.ext.foo == "bar"
 assert project.ext["foo"] == "bar"

 assert project.foo == "bar"
 assert project["foo"] == "bar"
 </pre>

 When using the first form, an <a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.UnknownPropertyException.html" title="class in org.gradle.api.plugins"><code>ExtraPropertiesExtension.UnknownPropertyException</code></a> exception will be thrown if the
 extension does not have a property called “<code>foo</code>”. When using the second forms (i.e. Groovy notation),
 Groovy's <a href="http://docs.groovy-lang.org/docs/groovy-2.4.11/html/gapi/groovy/lang/MissingPropertyException.html?is-external=true" title="class or interface in groovy.lang"><code>MissingPropertyException</code></a> will be thrown instead.</div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>name</code> - The name of the property to get the value of</dd>
<dt><span class="strong">Returns:</span></dt><dd>The value for the property with the given name.</dd>
<dt><span class="strong">Throws:</span></dt>
<dd><code><a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.UnknownPropertyException.html" title="class in org.gradle.api.plugins">ExtraPropertiesExtension.UnknownPropertyException</a></code> - if there is no property registered with the given name</dd></dl>
</li>
</ul>
<a name="set(java.lang.String, java.lang.Object)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>set</h4>
<pre>void&nbsp;set(<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;name,
       <a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;value)</pre>
<div class="block">Updates the value for, or creates, the registered property with the given name to the given value.

 When using an extra properties extension from Groovy, you can also set properties via Groovy's property syntax.
 All of the following lines of code are equivalent.

 <pre class='autoTested'>
 project.ext.set("foo", "bar")
 project.ext.foo = "bar"
 project.ext["foo"] = "bar"

 // Once the property has been created via the extension, it can be changed by the owner.
 project.foo = "bar"
 project["foo"] = "bar"
 </pre></div>
<dl><dt><span class="strong">Parameters:</span></dt><dd><code>name</code> - The name of the property to update the value of or create</dd><dd><code>value</code> - The value to set for the property</dd></dl>
</li>
</ul>
<a name="getProperties()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>getProperties</h4>
<pre><a href="https://docs.oracle.com/javase/7/docs/api/java/util/Map.html?is-external=true" title="class or interface in java.util">Map</a>&lt;<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>,<a href="https://docs.oracle.com/javase/7/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&gt;&nbsp;getProperties()</pre>
<div class="block">Returns all of the registered properties and their current values as a map.

 The returned map is detached from the extension. That is, any changes made to the map do not
 change the extension from which it originated.

 <pre class='autoTested'>
 project.version = "1.0"

 assert project.hasProperty("version")
 assert project.ext.properties.containsKey("version") == false

 project.ext.foo = "bar"

 assert project.ext.properties.containsKey("foo")
 assert project.ext.properties.foo == project.ext.foo

 assert project.ext.properties.every { key, value -&gt; project.properties[key] == value }
 </pre></div>
<dl><dt><span class="strong">Returns:</span></dt><dd>All of the registered properties and their current values as a map.</dd></dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar_bottom">
<!--   -->
</a><a href="#skip-navbar_bottom" title="Skip navigation links"></a><a name="navbar_bottom_firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-all.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../org/gradle/api/plugins/ExtensionContainer.html" title="interface in org.gradle.api.plugins"><span class="strong">Prev Class</span></a></li>
<li><a href="../../../../org/gradle/api/plugins/ExtraPropertiesExtension.UnknownPropertyException.html" title="class in org.gradle.api.plugins"><span class="strong">Next Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?org/gradle/api/plugins/ExtraPropertiesExtension.html" target="_top">Frames</a></li>
<li><a href="ExtraPropertiesExtension.html" target="_top">No Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li><a href="#nested_class_summary">Nested</a>&nbsp;|&nbsp;</li>
<li><a href="#field_summary">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field_detail">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method_detail">Method</a></li>
</ul>
</div>
<a name="skip-navbar_bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
